C++CMS
======

This is a great framework for writing websites with the C++ language.
I want to brag its lightweight and fast... but these terms are
seriously abused by other sluggish obese projects making this project
nothing short of weightless and lightning. How about an average of
2ms/page generation on modest hardware? Honestly dispatching and
rendering pages happens faster than MariaDB can retrieve data!

This is the tool I'm using to write the hand-rolled sections of the
"[Ye Ol' Pi Shack](https://YeOlPiShack.net/)" site combined with
[C++DB](http://cppcms.com/sql/cppdb/) for MySQL/MariaDB access.

In this repository I'll publish my changes to the framework. Right
now these are very minimal changes, which are somewhat questionable
as to whether they are the right approach. But the upstream author
didn't want to discuss it, leaving me to reverse engineer. Much more
of that needs doing before I'm confident. None the less I'm using
these changes.

Original upstream source is in the "master" branch and my
customizations are in the "yops" branch.



Customizations
--------------

  1. Change built in file server to serve from sub-URLs below /, so
     the app can land on /.

  2. Change embedded web server's app handling to allow using "" as
     an app _path_ so that my app can reside on /.

I use the embeddable web server as my primary means of web
development. Compile, run, test, ... Easy peasy! Like Ruby on Rails
or Django. In order to do that my web app needs to be _mounted_ to /,
as that's where **all** websites begin. Hence these patches to allow
the embeddable server to be configured like I'd setup Apache or
NginX.

I suspect I'll be revamping all of the URL handling before I'm done.



***WARNING***
-------------

All bragging aside this is not a CMS in the manner of WordPress,
Drupal, Joomla, ... This is simply a tool to field requests, merge
templates with data and present the results to a browser. But there
are a couple of projects available one may be able to use to get a
jump start with:
[Wiki++](http://cppcms.com/wikipp/en/page/install_wikipp) &
[C++Blog](http://cppcms.com/wikipp/en/page/install_cppblog)
